var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { print, } from 'graphql';
import { getMainDefinition, buildQueryFromSelectionSet, hasDirectives, removeClientSetsFromDocument, mergeDeep, warnOnceInDevelopment, argumentsObjectFromField, resultKeyNameFromField, getDirectiveInfoFromField, getFragmentDefinitions, createFragmentMap, shouldInclude, isField, isInlineFragment, } from 'apollo-utilities';
import { capitalizeFirstLetter } from '../util/capitalizeFirstLetter';
var LocalState = (function () {
    function LocalState(_a) {
        var cache = _a.cache, client = _a.client, initializers = _a.initializers, resolvers = _a.resolvers, typeDefs = _a.typeDefs, fragmentMatcher = _a.fragmentMatcher;
        this.resolvers = {};
        this.firedInitializers = [];
        this.cache = cache;
        if (client) {
            this.client = client;
        }
        if (initializers) {
            this.runInitializersSync(initializers);
        }
        if (resolvers) {
            this.addResolvers(resolvers);
        }
        if (typeDefs) {
            this.setTypeDefs(typeDefs);
        }
        if (fragmentMatcher) {
            this.setFragmentMatcher(fragmentMatcher);
        }
    }
    LocalState.prototype.runInitializers = function (initializers) {
        var _this = this;
        if (!initializers) {
            throw new Error('Invalid/missing initializers');
        }
        var mergedInitializers = this.mergeInitializers(initializers);
        var initializerPromises = [];
        this.processInitializers(mergedInitializers, function (fieldName, initializer) {
            initializerPromises.push(Promise.resolve(initializer()).then(function (result) {
                var _a;
                if (result !== undefined) {
                    _this.cache.writeData({ data: (_a = {}, _a[fieldName] = result, _a) });
                }
            }));
        });
        return Promise.all(initializerPromises);
    };
    LocalState.prototype.runInitializersSync = function (initializers) {
        var _this = this;
        if (!initializers) {
            throw new Error('Invalid/missing initializers');
        }
        var mergedInitializers = this.mergeInitializers(initializers);
        this.processInitializers(mergedInitializers, function (fieldName, initializer) {
            var _a;
            var result = initializer(_this);
            if (result !== undefined) {
                _this.cache.writeData({ data: (_a = {}, _a[fieldName] = result, _a) });
            }
        });
    };
    LocalState.prototype.addResolvers = function (resolvers) {
        var _this = this;
        if (Array.isArray(resolvers)) {
            resolvers.forEach(function (resolverGroup) {
                _this.resolvers = mergeDeep(_this.resolvers, resolverGroup);
            });
        }
        else {
            this.resolvers = mergeDeep(this.resolvers, resolvers);
        }
    };
    LocalState.prototype.setResolvers = function (resolvers) {
        this.resolvers = {};
        this.addResolvers(resolvers);
    };
    LocalState.prototype.getResolvers = function () {
        return this.resolvers;
    };
    LocalState.prototype.runResolvers = function (_a) {
        var document = _a.document, remoteResult = _a.remoteResult, context = _a.context, variables = _a.variables, onError = _a.onError;
        return __awaiter(this, void 0, void 0, function () {
            var localResult, rootValue, data, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        localResult = {};
                        if (!document) return [3, 4];
                        rootValue = this.buildRootValueFromCache(document, variables);
                        rootValue = rootValue ? mergeDeep(rootValue, remoteResult) : remoteResult;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4, this.resolveDocument(document, rootValue, context, variables, { fragmentMatcher: this.fragmentMatcher })];
                    case 2:
                        data = _b.sent();
                        localResult = data.result;
                        return [3, 4];
                    case 3:
                        error_1 = _b.sent();
                        if (onError) {
                            onError(error_1);
                            return [2];
                        }
                        else {
                            throw error_1;
                        }
                        return [3, 4];
                    case 4: return [2, __assign({}, remoteResult, localResult)];
                }
            });
        });
    };
    LocalState.prototype.setTypeDefs = function (typeDefs) {
        this.typeDefs = typeDefs;
    };
    LocalState.prototype.getTypeDefs = function () {
        return this.typeDefs;
    };
    LocalState.prototype.setFragmentMatcher = function (fragmentMatcher) {
        this.fragmentMatcher = fragmentMatcher;
    };
    LocalState.prototype.getFragmentMatcher = function () {
        return this.fragmentMatcher;
    };
    LocalState.prototype.clientQuery = function (document) {
        return hasDirectives(['client'], document) ? document : null;
    };
    LocalState.prototype.serverQuery = function (document) {
        return removeClientSetsFromDocument(document);
    };
    LocalState.prototype.prepareContext = function (context) {
        if (context === void 0) { context = {}; }
        var cache = this.cache;
        var schemas = [];
        if (this.typeDefs) {
            var directives = 'directive @client on FIELD';
            var definition = this.normalizeTypeDefs(this.typeDefs);
            schemas = schemas.concat([{ definition: definition, directives: directives }]);
        }
        var newContext = __assign({}, context, { cache: cache, getCacheKey: function (obj) {
                if (cache.config) {
                    return cache.config.dataIdFromObject(obj);
                }
                else {
                    throw new Error('To use context.getCacheKey, you need to use a cache that has ' +
                        'a configurable dataIdFromObject, like apollo-cache-inmemory.');
                }
            }, schemas: schemas });
        return newContext;
    };
    LocalState.prototype.addExportedVariables = function (document, variables, context) {
        if (variables === void 0) { variables = {}; }
        if (context === void 0) { context = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var exportedVariables, rootValue, updatedContext, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        exportedVariables = {};
                        if (!document) return [3, 2];
                        rootValue = this.buildRootValueFromCache(document, variables);
                        updatedContext = this.prepareContext(context);
                        return [4, this.resolveDocument(document, rootValue || {}, updatedContext, variables)];
                    case 1:
                        data = _a.sent();
                        exportedVariables = data.exportedVariables;
                        _a.label = 2;
                    case 2: return [2, __assign({}, variables, exportedVariables)];
                }
            });
        });
    };
    LocalState.prototype.resetInitializers = function () {
        this.firedInitializers = [];
    };
    LocalState.prototype.mergeInitializers = function (initializers) {
        var mergedInitializers = {};
        if (Array.isArray(initializers)) {
            initializers.forEach(function (initializerGroup) {
                mergedInitializers = __assign({}, mergedInitializers, initializerGroup);
            });
        }
        else {
            mergedInitializers = initializers;
        }
        return mergedInitializers;
    };
    LocalState.prototype.processInitializers = function (initializers, runFunc) {
        var _this = this;
        var alreadyFired = [];
        Object.keys(initializers).forEach(function (fieldName) {
            if (_this.firedInitializers.indexOf(fieldName) < 0) {
                runFunc(fieldName, initializers[fieldName]);
                _this.firedInitializers.push(fieldName);
            }
            else {
                alreadyFired.push(fieldName);
            }
        });
        if (alreadyFired.length > 0) {
            warnOnceInDevelopment("You're attempting to re-fire initializers for fields that have " +
                'already been initalized once. These repeat initializer calls have ' +
                'been ignored. If you really want them to run again, ' +
                'call `ApolloClient.resetInitializers()` first. ' +
                ("Fields: " + alreadyFired.join(', ')));
        }
    };
    LocalState.prototype.buildRootValueFromCache = function (document, variables) {
        var query = buildQueryFromSelectionSet(document);
        var cachedData = this.cache.diff({
            query: query,
            variables: variables,
            optimistic: false,
        });
        return cachedData.result;
    };
    LocalState.prototype.normalizeTypeDefs = function (typeDefs) {
        var defs = Array.isArray(typeDefs) ? typeDefs : [typeDefs];
        return defs
            .map(function (typeDef) { return (typeof typeDef === 'string' ? typeDef : print(typeDef)); })
            .map(function (str) { return str.trim(); })
            .join('\n');
    };
    LocalState.prototype.resolveDocument = function (document, rootValue, context, variables, execOptions) {
        if (execOptions === void 0) { execOptions = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var mainDefinition, fragments, fragmentMap, resultMapper, definitionOperation, defaultOperationType, fragmentMatcher, _a, cache, client, execContext, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        mainDefinition = getMainDefinition(document);
                        fragments = getFragmentDefinitions(document);
                        fragmentMap = createFragmentMap(fragments);
                        resultMapper = execOptions.resultMapper;
                        definitionOperation = mainDefinition
                            .operation;
                        defaultOperationType = definitionOperation
                            ? capitalizeFirstLetter(definitionOperation)
                            : 'Query';
                        fragmentMatcher = execOptions.fragmentMatcher || (function () { return true; });
                        _a = this, cache = _a.cache, client = _a.client;
                        execContext = {
                            fragmentMap: fragmentMap,
                            context: __assign({}, (context || {}), { cache: cache,
                                client: client }),
                            variables: variables || {},
                            resultMapper: resultMapper,
                            fragmentMatcher: fragmentMatcher,
                            defaultOperationType: defaultOperationType,
                            exportedVariables: {},
                        };
                        return [4, this.resolveSelectionSet(mainDefinition.selectionSet, rootValue, execContext)];
                    case 1:
                        result = _b.sent();
                        return [2, {
                                result: result,
                                exportedVariables: execContext.exportedVariables,
                            }];
                }
            });
        });
    };
    LocalState.prototype.resolveSelectionSet = function (selectionSet, rootValue, execContext) {
        return __awaiter(this, void 0, void 0, function () {
            var fragmentMap, context, variables, result, execute;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fragmentMap = execContext.fragmentMap, context = execContext.context, variables = execContext.variables;
                        result = {};
                        execute = function (selection) { return __awaiter(_this, void 0, void 0, function () {
                            var fieldResult, resultFieldKey, fragment, typeCondition, fragmentResult;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!shouldInclude(selection, variables)) {
                                            return [2];
                                        }
                                        if (!isField(selection)) return [3, 2];
                                        return [4, this.resolveField(selection, rootValue, execContext)];
                                    case 1:
                                        fieldResult = _a.sent();
                                        resultFieldKey = resultKeyNameFromField(selection);
                                        if (fieldResult !== undefined) {
                                            if (result[resultFieldKey] === undefined) {
                                                result[resultFieldKey] = fieldResult;
                                            }
                                            else {
                                                this.mergeIntoResults(result[resultFieldKey], fieldResult);
                                            }
                                        }
                                        return [3, 4];
                                    case 2:
                                        fragment = void 0;
                                        if (isInlineFragment(selection)) {
                                            fragment = selection;
                                        }
                                        else {
                                            fragment = fragmentMap[selection.name.value];
                                            if (!fragment) {
                                                throw new Error("No fragment named " + selection.name.value);
                                            }
                                        }
                                        if (!(fragment && fragment.typeCondition)) return [3, 4];
                                        typeCondition = fragment.typeCondition.name.value;
                                        if (!execContext.fragmentMatcher(rootValue, typeCondition, context)) return [3, 4];
                                        return [4, this.resolveSelectionSet(fragment.selectionSet, rootValue, execContext)];
                                    case 3:
                                        fragmentResult = _a.sent();
                                        this.mergeIntoResults(result, fragmentResult);
                                        _a.label = 4;
                                    case 4: return [2, Promise.resolve(undefined)];
                                }
                            });
                        }); };
                        return [4, Promise.all(selectionSet.selections.map(execute))];
                    case 1:
                        _a.sent();
                        return [2, execContext.resultMapper
                                ? execContext.resultMapper(result, rootValue)
                                : result];
                }
            });
        });
    };
    LocalState.prototype.resolveField = function (field, rootValue, execContext) {
        return __awaiter(this, void 0, void 0, function () {
            var variables, fieldName, args, aliasedFieldName, info, aliasUsed, result, resolverType, resolverMap, resolve, exportedVariable;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        variables = execContext.variables;
                        fieldName = field.name.value;
                        args = argumentsObjectFromField(field, variables);
                        aliasedFieldName = resultKeyNameFromField(field);
                        info = {
                            isLeaf: !field.selectionSet,
                            resultKey: aliasedFieldName,
                            directives: getDirectiveInfoFromField(field, variables),
                        };
                        aliasUsed = fieldName !== aliasedFieldName;
                        resolverType = rootValue.__typename || execContext.defaultOperationType;
                        resolverMap = this.resolvers[resolverType];
                        if (!resolverMap) return [3, 2];
                        resolve = resolverMap[aliasUsed ? fieldName : aliasedFieldName];
                        if (!resolve) return [3, 2];
                        return [4, resolve(rootValue, args, execContext.context, info)];
                    case 1:
                        result = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (result === undefined) {
                            result = rootValue[aliasedFieldName] || rootValue[fieldName];
                        }
                        if (info.directives && info.directives.export) {
                            exportedVariable = info.directives.export.as;
                            execContext.exportedVariables[exportedVariable] = result;
                        }
                        if (!field.selectionSet) {
                            return [2, result];
                        }
                        if (result == null) {
                            return [2, result];
                        }
                        if (Array.isArray(result)) {
                            return [2, this.resolveSubSelectedArray(field, result, execContext)];
                        }
                        if (field.selectionSet) {
                            return [2, this.resolveSelectionSet(field.selectionSet, result, execContext)];
                        }
                        return [2];
                }
            });
        });
    };
    LocalState.prototype.resolveSubSelectedArray = function (field, result, execContext) {
        var _this = this;
        return Promise.all(result.map(function (item) {
            if (item === null) {
                return null;
            }
            if (Array.isArray(item)) {
                return _this.resolveSubSelectedArray(field, item, execContext);
            }
            if (field.selectionSet) {
                return _this.resolveSelectionSet(field.selectionSet, item, execContext);
            }
        }));
    };
    LocalState.prototype.mergeIntoResults = function (dest, src) {
        var _this = this;
        if (src !== null && typeof src === 'object') {
            Object.keys(src).forEach(function (key) {
                var srcVal = src[key];
                if (!Object.prototype.hasOwnProperty.call(dest, key)) {
                    dest[key] = srcVal;
                }
                else {
                    _this.mergeIntoResults(dest[key], srcVal);
                }
            });
        }
    };
    return LocalState;
}());
export { LocalState };
//# sourceMappingURL=LocalState.js.map